/* ZUES Assembler source file -------------------------------*/

/* ######################################### 
   #                                         
   # (C) JPG 1993	filegen.c                  
   #                                         
   # Version 1.4			     
   #                                         
   # Updated 98/11/19 at 19:27:50                                 
   #                                        
   # ident @(#)filegen.c	1.4 		     		     
   # 
   # This program is free software; you can redistribute it and/or modify
   # it under the terms of the GNU General Public License as published by
   # the Free Software Foundation; either version 2 of the License, or
   # (at your option) any later version.
   #
   # This program is distributed in the hope that it will be useful,
   # but WITHOUT ANY WARRANTY; without even the implied warranty of
   # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   # GNU General Public License for more details.
   #
   # You should have received a copy of the GNU General Public License
   # along with this program; if not, write to the Free Software
   # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   #                                        
   ######################################### */

/* include header files here		> */

#include "filegen.h"

/* source starts here			> */

int def_gen( void )
{
	return VALID;

}

int deft_gen( int linenum, int *offset, int address, int type )
{
	extern FILE *list_file;
	extern int assem_state;
	extern int trunc_lines;	
	extern int diag_state;
	
	int index, temp_num, len, temp_result = VALID, return_result = VALID;
	char temp_str[ MAXLINE ], line[ MAXLINE ] = { '\0' };
	char o_line[ MAXLINE ] = { '\0' };
	int ( *function )( char [] );

	if ( diag_state == FULL )
		printf( "**deft_gen starts:**\n" );

	if ( assem_state == SECOND_PASS ) {
		fprintf( list_file, "%-*d", ADDR_LEN, address );
		if ( type == A_STRING ) {
			function = &pop_str;
		} else {
			function = &pop_str;	
		}
		while ( (*function)( temp_str ) == VALID ) {
			char h_byte[3];

			for ( index = 0; temp_str[ index ] != '\0'; index++ ) {
				hexify( (int) temp_str[ index ], h_byte, linenum );
				obj_gen( (int) temp_str[ index ], address++, linenum ); 
				(void) strcat( line, h_byte );
				( *offset )++;
			}				
/*			hexify( '\0', h_byte, linenum );
			obj_gen( '\0', address++, linenum );
			(void) strcat( line, h_byte );
			( *offset )++;
*/

			if ( type == A_STRING ) {
				hexify( '\n', h_byte, linenum );
				obj_gen( '\n', address++, linenum ); 
				(void) strcat( line, h_byte );
				( *offset )++;
			}
		

		/*

			hexify( (int) temp_str[ index ], h_byte, linenum );
			obj_gen( (int) temp_str[ index ], address++, linenum ); 
			(void) strcat( line, h_byte );
			( *offset )++; 
		*/
	
		}

		if ( ( ( len = ( int ) strlen( line ) ) > HEX_LEN ) && ( trunc_lines == INVALID ) ) {	
			fprintf( list_file, "%-*.*s", HEX_LEN, HEX_LEN, line );
			fprintf( list_file, "%*d\t", LINE_LEN, linenum ); 
			if ( invert_words( A_ASSEM, linenum ) != INVALID ){

				char assem_word[ MAXLINE ];

				while ( pop_assem( &assem_word ) == VALID ){
					fprintf( list_file, "%s", assem_word );
				}
			}
			while ( ( len = ( int ) strlen( line ) ) > HEX_LEN ) {

				fprintf( list_file, "\n" );
				fprintf( list_file, "%-*s", ADDR_LEN, "" );
				strcpy( o_line, &line[ HEX_LEN ] );
				strcpy( line, o_line );
					
				fprintf( list_file, "%-*.*s",HEX_LEN, HEX_LEN, line );				
			}
 	
		} else {
			fprintf( list_file, "%-*.*s", HEX_LEN, HEX_LEN, line );
			fprintf( list_file, "%*d\t", LINE_LEN, linenum ); 
		}
		
	} else {
		/* fprintf( list_file, "%-*d", ADDR_LEN, address ); */ 
		if ( type == A_STRING ) {
			function = &pop_str;
		} else {
			function = &pop_str;	
		}
		while ( (*function)( temp_str ) == VALID ) {
			for ( index = 0; temp_str[ index ] != '\0'; index++ ) {
				( *offset )++;
			}				
			if ( type == A_STRING ) {
				( *offset )++;
			}
			/*
			( *offset )++; 
			*/
	
		}
	}

	if ( diag_state == FULL )
		printf( "**deft_gen ends:**\n\n" );

	return return_result;

}

int defw_gen( int linenum, int *offset, int address )
{
	extern FILE *list_file;
	extern int assem_state;
	extern int trunc_lines;
	extern int diag_state;
	extern int addr_resolve;
	extern int addr_resolve_line;

	int temp_num, len, return_result = VALID;
	char line[ MAXLINE ] = { '\0' };
	char o_line[ MAXLINE ] = { '\0' };

	if ( diag_state == FULL ) 
		printf( "**defw_gen starts:**\n" );
	
	if ( assem_state == SECOND_PASS ) {

		fprintf( list_file, "%-*d", ADDR_LEN, address );

		if ( ( assem_state == SECOND_PASS ) && ( addr_resolve == VALID ) ) {

			extern struct addr_name_list *addr_names;
			addr_resolve = INVALID;

			if ( addr_resolve_line != linenum ) { 
				on_error( "line numbers dont match", linenum, WARN );
			}

			(void) calc_addr_names( addr_names, address, e_, NON, 0, 0, 2 );
			addr_names = (struct addr_name_list *) clear_name_list( addr_names );

		}

		while ( pop( &temp_num ) == VALID ) {

			char h_byte[ 3 ];
			int bytes[ 2 ];

			if ( temp_num < 0 ) {
				
				/* twos complement the word */
				
				temp_num = ( MAX_AWORD & ( ( ~ ( -1 * temp_num ) ) + 1 ) );
			}

			one_two_l( temp_num, bytes, 2 );

			hexify( bytes[0], h_byte, linenum );
			obj_gen( bytes[0], address++, linenum ); 
			(void) strcat( line, h_byte );
			(*offset)++;
			hexify( bytes[1], h_byte, linenum );
			obj_gen( bytes[1], address++, linenum ); 
			(void) strcat( line, h_byte );
			(*offset)++;
		}

		if ( ( ( len = ( int ) strlen( line ) ) > HEX_LEN ) && ( trunc_lines == INVALID ) ) {	
			fprintf( list_file, "%-*.*s", HEX_LEN, HEX_LEN, line );
			fprintf( list_file, "%*d\t", LINE_LEN, linenum ); 
			if ( invert_words( A_ASSEM, linenum ) != INVALID ){

				char assem_word[ MAXLINE ];

				while ( pop_assem( &assem_word ) == VALID ){
					fprintf( list_file, "%s", assem_word );
				}
			}
			while ( ( len = ( int ) strlen( line ) ) > HEX_LEN ) {

				fprintf( list_file, "\n" );
				fprintf( list_file, "%-*s", ADDR_LEN, "" );
				strcpy( o_line, &line[ HEX_LEN ] );
				strcpy( line, o_line );
					
				fprintf( list_file, "%-*.*s",HEX_LEN, HEX_LEN, line );				
			}
 	
		} else {
			fprintf( list_file, "%-*.*s", HEX_LEN, HEX_LEN, line );
			fprintf( list_file, "%*d\t", LINE_LEN, linenum ); 
		}
	} else {
		while ( pop( &temp_num ) == VALID ){
			(*offset)+=2;
		}
	}
	if ( diag_state == FULL ) 
		printf( "**defw_gen starts:**\n" );
	return return_result;
}

int defb_gen( int linenum, int *count, int address )
{
	extern int diag_state;
	extern FILE *list_file;
	extern int assem_state;
	extern int trunc_lines;

	int temp_num, len, return_result = VALID;
	char line[ MAXLINE ] = { '\0' };
	char o_line[ MAXLINE ] = { '\0' };

	if ( diag_state == FULL ) 
		printf( "**defb_gen starts:**\n" );

	if ( assem_state == SECOND_PASS ){
		fprintf( list_file, "%-*d", ADDR_LEN, address );
		while ( pop( &temp_num ) == VALID ){
			char h_byte[ 3 ];
			
			if ( temp_num < 0 ) {

				/* twos complement the byte if its negative */

				temp_num = 255 & ( ( ~ ( -1 * temp_num ) ) + 1 );
			} else if ( temp_num > MAX_ABYTE ) {
				on_error( "byte out of range", linenum, EXPR );
				temp_num = MAX_ABYTE;
			}
			hexify( temp_num, h_byte, linenum );
			obj_gen( temp_num, address++, linenum ); 
			(void) strcat( line, h_byte );
			(*count)++;
		}
		if ( ( ( len = ( int ) strlen( line ) ) > HEX_LEN ) && ( trunc_lines == INVALID ) ){	
			fprintf( list_file, "%-*.*s", HEX_LEN, HEX_LEN, line );
			fprintf( list_file, "%*d\t", LINE_LEN, linenum ); 
			if ( invert_words( A_ASSEM, linenum ) != INVALID ){

				char assem_word[ MAXLINE ];

				while ( pop_assem( &assem_word ) == VALID ){
					fprintf( list_file, "%s", assem_word );
				}
			}
			while ( ( len = ( int ) strlen( line ) ) > HEX_LEN ){

				fprintf( list_file, "\n" );
				fprintf( list_file, "%-*s", ADDR_LEN, "" );
				strcpy( o_line, &line[ HEX_LEN ] );
				strcpy( line, o_line );
					
				fprintf( list_file, "%-*.*s",HEX_LEN, HEX_LEN, line );			
			}
 	
		} else {
			fprintf( list_file, "%-*.*s", HEX_LEN, HEX_LEN, line );
			fprintf( list_file, "%*d\t", LINE_LEN, linenum ); 
		}
	} else {
		while ( pop( &temp_num ) == VALID ){
			(*count)++;
		}
	}
	if ( diag_state == FULL ) 
		printf( "**defb_gen starts:**\n\n" );

	return return_result;

}

int obj_gen( int code, int address, int linenum ) 
{
	extern FILE *obj_file;
	extern diag_state;

	if ( diag_state == FULL ) 
		printf( "**obj_gen starts:**\n" );

	fprintf( obj_file, "<%0*d>", ADDR_LEN, address );
	fprintf( obj_file, "<%0*d>\n", 3, code );

	(void) srec_gen( code, address, CONTINUE, linenum );
	
	if ( diag_state == FULL ) 
		printf( "**obj_gen ends:**\n\n" );

	return VALID;
}

/* srec_gen:	function to generate Motorola S-records for the
		object file. */

int srec_gen( int byte, int address, int type, int linenum )
{
	extern int mem_offset;
	extern int srec_bytes;
	extern int srec_state;
	extern int last_address;
	extern int line_address;

	char empty_byte[] = { '0', '0', '\0' };

	static char out_line[ MAXLINE ];
	static int out_number[ MAXLINE ]; 
	static int num_bytes = 0;
	static int initial = VALID;

	char *point = out_line;

	char hex_byte[ MAXLINE ];

	int return_result = VALID;

	if ( srec_state == FULL ) {

		if ( initial == VALID ) {
			srec_formgen( &num_bytes, &line_address, out_number, out_line, FULL, mem_offset, linenum );
			initial = INVALID;
		}
	
		hexify_up( byte, hex_byte, linenum );
	
		if ( type == CONTINUE ) {
			if ( last_address != ( address - 1 ) ) {
		
				int index;
	
				for ( index = last_address; index < ( address -1 ) ; index++ ) {
					(void) strcat( out_line, empty_byte );
					out_number[ num_bytes ] = 0;
					num_bytes++;
					
					if ( num_bytes >= srec_bytes ) {
						srec_formgen( &num_bytes, &line_address, out_number, out_line, type, mem_offset, linenum );
					}
				}
				(void) strcat( out_line, hex_byte );
				out_number[ num_bytes ] = byte;
				num_bytes++;
			} else {
				(void) strcat( out_line, hex_byte );
				out_number[ num_bytes ] = byte;
				num_bytes++;
			}
	
			if ( num_bytes >= srec_bytes ) {
				srec_formgen( &num_bytes, &line_address, out_number, out_line, type, mem_offset, linenum );
			}
	
		last_address = address;
	
		} else if ( type == STOP ) {
	
			/* Were not expecting a byte here so all we will do is 
			   format the remaining line and exit */	
			
	
			srec_formgen( &num_bytes, &line_address, out_number, out_line, CONTINUE, mem_offset, linenum );
			line_address = 0;
			srec_formgen( &num_bytes, &line_address, out_number, out_line, STOP, mem_offset, linenum );
	
		} else {
	
			/* This is undefined so generate a system error */
	
			on_error( "srec_gen: undefined message type", linenum, SYSTEM );
			return_result = INVALID;
		}
	}	
	return return_result;
}

int srec_formgen( int *num_bytes, int *line_address, int *numbers, char *line, int type, int offset, int linenum )
{
	extern FILE *srec_file;
	extern int srec_format;

	int sum_line = 0;
	int addr_sum = 0;
	int line_check = 0;
	int add_addr = *num_bytes;

	char hex_byte[ MAXLINE ];

	int tally = 0;		/* the number of actual bytes in the line */
	int index = 0;

	if ( line[ 0 ] != '\0' ) {

		/* ie the lines not empty so sum the line for the sum check */
		while ( line[ index ] != '\0' ) {
			index = index + 2;
			tally++;
			sum_line = sum_line + *(numbers++);

		}
	}

	addr_to_hexsum( &addr_sum, *line_address );

	switch ( srec_format ) {
	case S1 : 
		{
			switch ( type ) {
			case FULL :
				{
				
					*num_bytes = *num_bytes + 3;
					fprintf( srec_file, "S0%0*X%0*X%s", 2, *num_bytes, 4, *line_address, line );
					break;
				}
			case CONTINUE :
				{
					*num_bytes = *num_bytes + 3;
					fprintf( srec_file, "S1%0*X%0*X%s", 2, *num_bytes, 4, *line_address, line );
					break;
				}
			case STOP :
				{
					*num_bytes = *num_bytes + 3;
					fprintf( srec_file, "S9%0*X%0*X%s", 2, *num_bytes, 4, *line_address, line );
					break;
				}
			}
		break;
		}
	case S2 :
		{
			switch ( type ) {
			case FULL :
				{
				
					*num_bytes = *num_bytes + 3;
					fprintf( srec_file, "S0%0*X%0*X%s", 2, *num_bytes, 4, *line_address, line );
					break;
				}
			case CONTINUE :
				{
					*num_bytes = *num_bytes + 4;
					fprintf( srec_file, "S2%0*X%0*X%s", 2, *num_bytes, 6, *line_address, line );
					break;
				}
			case STOP :
				{
					*num_bytes = *num_bytes + 4;
					fprintf( srec_file, "S8%0*X%0*X%s", 2, *num_bytes, 6, *line_address, line );
					break;
				}
			}
			break;
		}
	case S3:
		{
			switch ( type ) {
			case FULL :
				{
				
					*num_bytes = *num_bytes + 3;
					fprintf( srec_file, "S0%0*X%0*X%s", 2, *num_bytes, 4, *line_address, line );
					break;
				}
			case CONTINUE :
				{
					*num_bytes = *num_bytes + 5;
					fprintf( srec_file, "S3%0*X%0*X%s", 2, *num_bytes, 8, *line_address, line );
					break;
				}
			case STOP :
				{
					*num_bytes = *num_bytes + 5;
					fprintf( srec_file, "S7%0*X%0*X%s", 2, *num_bytes, 8, *line_address, line );
					break;
				}
			}
			break;
		}	
	}
				
	/* Dont forget to add in the address checksum and
	   the number of bytes !! */
			
	addr_sum = addr_sum + *num_bytes;
	sum_line = sum_line + addr_sum;

	line_check = ( 255 & ( ~ sum_line ) );

	fprintf( srec_file, "%0*X\n", 2, line_check );
		
	line[ 0 ] = '\0';
	*line_address = *line_address + add_addr;
	*num_bytes = 0;

}







/* org_gen:	function to correctly print an org expression */

int org_gen( int line_num, int address )
{
	extern FILE *list_file;
	extern int assem_state;
	extern int diag_state;
	extern int last_address;
	extern int line_address;

	int return_result = VALID;

	if ( diag_state == FULL ) 
		printf( "**org_gen starts:**\n" );

	if ( assem_state == SECOND_PASS ){
		fprintf( list_file, "%-*d", ADDR_LEN, address );
		fprintf( list_file, "%*s", HEX_LEN, "" );
		fprintf( list_file, "%*d\t", LINE_LEN, line_num ); 

	}

	if ( diag_state == FULL ) 
		printf( "**org_gen ends:**\n\n" );

	return return_result;
}

int space_gen( int linenum )
{
	extern FILE *list_file;
	extern int assem_state;
	extern int diag_state;

	int return_result = VALID;

	if ( diag_state == FULL ) 
		printf( "**space_gen starts:**\n" );
	if ( assem_state == SECOND_PASS ){
		fprintf( list_file, "%*s", TOTAL_LEN, "" );
		fprintf( list_file, "%*d\t", LINE_LEN, linenum ); 
	}

	if ( diag_state == FULL ) 
		printf( "**space_gen ends:**\n\n" );
	return return_result;
}

/* list_gen:	a function that prints the address, a hex dump of the
		assembler, the line number and the original text. 
		Should only be called on the final pass of the assemble  */

int list_gen( int codes[], int linenum, int length, int address )
{
	extern FILE *list_file;
	extern diag_state;

	int return_result = INVALID;
	int loop_i;
	int t_addr = address;

	char tab[] = { '\t', '\0' };
	char line[ MAXLINE ] = { '\0' };
	
	if ( diag_state == FULL ) 
		printf( "**list_gen starts:**\n" );

	fprintf( list_file, "%-*d", ADDR_LEN, address );
	for ( loop_i = 0; loop_i < length; loop_i++ ){
		char h_byte[ 3 ];

		hexify_up( codes[ loop_i ], h_byte, linenum );
		obj_gen( codes[ loop_i ], t_addr++, linenum );
		(void) strcat( line, h_byte );
	}
	fprintf( list_file, "%-*s",HEX_LEN, line );
	fprintf( list_file, "%*d\t", LINE_LEN, linenum ); 
	if ( invert_words( A_ASSEM, linenum ) != INVALID ){

		char assem_word[ MAXLINE ];

		while ( pop_assem( &assem_word ) == VALID ){
			fprintf( list_file, "%s", assem_word );
		}
	}

	if ( diag_state == FULL ) 
		printf( "**list_gen ends:**\n\n" );

	return return_result;

}

/* hexify:	a function to convert a byte integer into a hex string
		representation	*/

int hexify( int code, char byte[], int linenum )
{
	extern char hex_bits[];

	int temp_num1, temp_num2, return_result;


	temp_num1 = code / 16;
	temp_num2 = code % 16;

	if ( ( temp_num1 < 16 ) && ( temp_num2 < 16 ) ){
		if ( temp_num1 == 0 ){
			byte[0] = '0';
		} else {
			byte[0] = hex_bits[ temp_num1 ];
		}
		byte[1] = hex_bits[ temp_num2 ];
		return_result = VALID;
	} else {
		on_error( "hexify: cant turn number into hex", linenum, EXPR );
		return_result = INVALID;
	}
		

	byte[2] = '\0';
	return return_result;
}

/* hexify_up:	a function to convert a byte integer into a hex string
		representation in upper case 	*/

int hexify_up( int code, char byte[], int linenum )
{
	extern char hex_bits_up[];

	int temp_num1, temp_num2, return_result;


	temp_num1 = code / 16;
	temp_num2 = code % 16;

	if ( ( temp_num1 < 16 ) && ( temp_num2 < 16 ) ){
		if ( temp_num1 == 0 ){
			byte[0] = '0';
		} else {
			byte[0] = hex_bits_up[ temp_num1 ];
		}
		byte[1] = hex_bits_up[ temp_num2 ];
		return_result = VALID;
	} else {
		on_error( "hexify: cant turn number into hex", linenum, EXPR );
		return_result = INVALID;
	}
		

	byte[2] = '\0';
	return return_result;
}


/* print_newline:	an end of line function to dump any comments
			out to the list file	*/

int print_newline( linenum )
{
	extern FILE *list_file;
	extern int assem_state;

	char assem_word[ MAXLINE ];
	if ( assem_state == SECOND_PASS ){	
		( void ) invert_words( A_ASSEM, linenum );
		while( pop_assem( assem_word ) == VALID )
			(void) fprintf( list_file, "%s", assem_word );

		(void) fprintf( list_file, "\n" );
	} 
	return VALID ;
}

/* addr_to_hexsum */

int addr_to_hexsum( int *bytesum, int address )
{
	int tmp_bytesum;

	*bytesum = 0;

	while ( ( address / 256 ) > 0 ) {
		tmp_bytesum = *bytesum + ( address / 256 );
		address = address - ( tmp_bytesum * 256 );
		*bytesum = tmp_bytesum;
	}
	*bytesum = *bytesum + address;

	return;
}
 

