/* ZUES Assembler header file ---------------------------------*/

/* ######################################### 
   #                                         
   # (C) JPG 1993	global.h                  
   #                                         
   # Version 1.4			     
   #                                         
   # Updated 98/11/19 at 19:27:49                                 
   #                                        
   # ident @(#)global.h	1.4 		     		     
   #                                        
   ######################################### */

/* include global definitions here          > */

#define VERSION 1.4

#define MAXLINE 1000
#define MAXSTRING 1000
#define MAXPASSES 10
#define MAX_ABYTE 255
#define MIN_ABYTE 0
#define MAX_SBYTE 127
#define MIN_SBYTE -128
#define MAX_RBYTE 127
#define MIN_RBYTE -128
#define MAX_AWORD 65535
#define MIN_AWORD 0

enum errors { WARN, INIT, FILEH, SYNTAX, EXPR, ADDR, LABEL, SYSTEM, FINAL, HALT };
enum states { FIRST_PASS, SECOND_PASS };
enum returns { VALID, INVALID, NULL_EXPR, UNDEFINED };
enum nexts { CONTINUE, STOP, NO_OUTPUT, FULL, DONT_KNOW, QUIT };
enum optypes { r_, r_b_, rr_, rr_b_, e_, i_, i_e_, f_, n_, nn_, I_, E_, N_, NN_, R_, RR_, NON };
enum seq { SREGSEQ1, SREGSEQ2, DREGSEQ1, DREGSEQ2, FSEQ1, FSEQ2, BSEQ1, BSEQ2, ABYTE, SBYTE, RBYTE, AWORD, SWORD, RWORD, ALONG, SLONG, RLONG, NUMSEQ, NSEQ };
enum srectypes { S1, S2, S3 };

	/* seq: sequences and qualifiers
		
		SREGSEQ1:	single register sequence 1
		SREGSEQ2:	single register sequence 2
		DREGSEQ1 :	double register sequence 1
		DREGSEQ2 :	double register sequence 2
		FSEQ1	:	flag sequence 1
		FSEQ2	:	flag sequence 2
		BSEQ1	:	bit sequence 1
		BSEQ2	:	bit sequence 2
		ABYTE	:	absolute byte
		SBYTE	:	signed byte
		RBYTE	:	relative byte
		AWORD	:	absolute word
		SBYTE	:	signed byte
		RBYTE	:	relative byte
		ALONG	:	absolute long
		SLONG	:	signed long
		RLONG	:	relative long
	*/

enum oth_bits { A_TEXT, A_STRING, A_ASSEM };
enum some_more { MEM, OTHER };

struct addr_name_list {

	char name[ MAXSTRING ];
	struct addr_name_list *last;
	struct addr_name_list *next;

};

/* define global function definitions here      > */

int op_gen( int num, int top1, int top2, int sop1, int sop2, int *offset, int address, int linenum );
int on_error( char *, int, int );
struct addr_name_list *clear_name_list(  struct addr_name_list * );

/* define local function definitions here       > */
