/* ZUES Assembler source file -------------------------------*/

/* ######################################### 
   #                                         
   # (C) JPG 1993	main.c                  
   #                                         
   # Version 1.8			     
   #                                         
   # Updated 98/11/19 at 19:27:50                                 
   #                                        
   # ident @(#)main.c	1.8 		     		     
   # 
   # This program is free software; you can redistribute it and/or modify
   # it under the terms of the GNU General Public License as published by
   # the Free Software Foundation; either version 2 of the License, or
   # (at your option) any later version.
   #
   # This program is distributed in the hope that it will be useful,
   # but WITHOUT ANY WARRANTY; without even the implied warranty of
   # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   # GNU General Public License for more details.
   #
   # You should have received a copy of the GNU General Public License
   # along with this program; if not, write to the Free Software
   # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   #                                        
   ######################################### */

/* include header files here		> */

#include "main.h"

/* source starts here			> */

int main( int argc, char **argv )
{
	extern FILE *list_file;
	extern FILE *obj_file;
	extern FILE *srec_file;
	extern FILE *rel_file;

	extern char curr_file[];
	
	extern int trunc_lines;
	extern int format_space;
	extern int skip_blank;
	extern int diag_state;
	extern int list_state;
	extern int obj_state;
	extern int linenum;
	extern int srec_state;
	extern int srec_format;
	extern int srec_bytes;
	extern int mem_offset;
	extern int last_address;
	extern int line_address;
	extern char *optarg;
	extern int optind;
	
	FILE *source;

	char file_name[ MAXLINE ];
	char list_name[ MAXLINE ];
	char obj_name[ MAXLINE ];
	char rel_name[ MAXLINE ];
	char srec_name[ MAXLINE ];
	char dump_name[ MAXLINE ];
	char listfix[ MAXLINE ] = ".list";
	char objfix[ MAXLINE ] = ".zobj";
	char relfix[ MAXLINE ] = ".zrel";
	char postfix[ MAXLINE ] = ".z";
	char srecfix[ MAXLINE ] = { '\0' };
	char dumpfix[ MAXLINE ] = ".zdmp";

	char *tmp_file;

	int c; 
	int aflg = 0;
	int bflg = 0;
	int errflg = 0;

	line_address = 0;
	last_address = 0;

	while ( ( c = getopt( argc, argv, "dlnbftp:s:o:" ) ) != EOF ) {

		switch ( c ) {
			case 'd' : 
			{
				diag_state = FULL;
				printf("**diagnosticts on:**\n\n");
				break;
			}

			case 's' : 
			{
				char c = '0';
				c = *optarg;

				if ( ( c > '0' ) && ( c < '4' ) ) {
					switch ( c ) {
						case '1' : 
						{
							char srec_fix[] = ".s1";
	
							srec_format = S1;
							srec_state = FULL;
							(void) strcat ( srecfix, srec_fix );
							if ( diag_state == FULL ) {
								printf("**srec format on S1:**\n" );
							}
							break;
						}
						case '2' : 
						{
							char srec_fix[] = ".s2";

							srec_format = S2;
							srec_state = FULL;
							(void) strcat ( srecfix, srec_fix );
							if ( diag_state == FULL ) {
								printf("**srec format on S2:**\n" );
							}
							break;
						}
						case '3' : 
						{
							char srec_fix[] = ".s3";

							srec_format = S3;
							srec_state = FULL;
							(void) strcat ( srecfix, srec_fix );

							if ( diag_state == FULL ) {
								printf("**srec format on S3:**\n" );
							}
							break;
						}
						default :
						{
							on_error( "invalid Motorola format", linenum, HALT );
							break;
						}
					}
				} else {
					on_error( "invalid Motorola format", linenum, HALT );
				}
		
				break;
			}

			case 'l' :
				list_state = FULL;
				break;
			case 'n' :
				obj_state = FULL;
				break;
			case 'b' :
				skip_blank = VALID;
				break;
			case 'f' :
				format_space = VALID;
				break;
			case 't' :
				trunc_lines = VALID;
				break;

			case 'o' :
			{
				if ( optarg != NULL ) {

					last_address = (int) atoi( optarg );
					line_address = last_address;
				} else {

					errflg++;

				}
				break;
			}
				
			case 'p' : 
			{
				int temp_pass;

				if ( optarg != NULL ) {

					temp_pass = (int) atoi( optarg );
				} else {

					temp_pass = 0;
					errflg++;

				}

				if ( temp_pass > 0 ) {

					printf( "pass %d \n", temp_pass );
					max_passes = temp_pass;
						
				} else {

					on_error( "pass number out of bounds", linenum, FINAL );
					printf( "illegal number to pass\n" );
				}
			break;
			}	

			case '?' :
			{
				errflg++;
				break;
			}

			default :
			{
				(void) on_error( "usage: zues [-dlnbft] [-p <passes] [-s <format>] [-o <org>] files...\n", linenum, HALT );
				break;
			}
		}
	}

	if ( errflg ) {

		(void) on_error( "usage: zues [-dlnbft] [-p <passes] [-s <format>] [-o <org>] files...\n", linenum, HALT );

	}

	(void) init_hash();

	/* take it that the last argument is the source file */

	if ( optind < argc ) {

		char *point; 
		int len_str;
		char name[MAXLINE];

		strcpy( file_name, argv[ optind ] );
		strcpy( curr_file, file_name );
		len_str = strlen ( file_name );

	/* Modified 30/07/96 JPG
	   to allow multiple file inclusion, macros etc
	   by pre-processing the assembler through 'cpp'
	*/

		if ( (int) strcmp( &file_name[ len_str - 2 ], postfix ) == 0 ) {
			strncpy( name, file_name, len_str -2 );
			strcpy( list_name, name );
			strcpy( obj_name, name );
			strcat( list_name, listfix );
			strcat( obj_name, objfix );
			strcpy( dump_name, name );
			strcat( dump_name, dumpfix );
			strcpy( rel_name, name );
			strcat( rel_name, relfix );

			if (( source = fopen ( file_name, "r" )) != NULL ) {
		
				char	command[ MAXLINE ];

				FILE	*cpp_source;

				tmp_file = tempnam( "/tmp", "Z80" );

				(void) sprintf( command, "cpp %s > %s", file_name, tmp_file );

				system( command );

				if (( cpp_source = fopen( tmp_file, "r" )) != NULL ) {
				
					yyin = cpp_source;

				} else {
					char temp_line[MAXLINE]="cant open temp file for reading: ";

					( void ) strcat( temp_line, file_name );
					on_error( temp_line, 0, FILEH );
				}

			} else {	

				char temp_line[MAXLINE]="cant open for reading ";

				( void ) strcat( temp_line, file_name );
				on_error( temp_line, 0, FILEH );

			}
			if ( list_state == FULL ) {
				if (( list_file = fopen ( list_name, "w" )) == NULL ) {
					char temp_line[MAXLINE] = "cant open for writing ";
					( void ) strcat( temp_line, list_name );
					on_error( temp_line, 0, FILEH );
				}

				if ( ( dump_file = fopen( dump_name, "w" ) ) == NULL ) {
					char temp_line[ MAXLINE ] = "can't open for writing ";
					( void ) strcat( temp_line, dump_name );
					on_error( temp_line, 0, FILEH );
				}

			} else { 
				char list_name[] = "/dev/null";

				if (( list_file = fopen ( list_name, "w" )) == NULL ) {
					char temp_line[MAXLINE] = "cant open /dev/null for writing ";
					on_error( temp_line, 0, FILEH );
				}
			}
				
			if ( obj_state == FULL ) {
				if (( obj_file = fopen ( obj_name, "w" )) == NULL ) {
	 				char temp_line[MAXLINE] = "cant open for writing ";
					( void ) strcat( temp_line, obj_name );
					on_error( temp_line, 0, FILEH );
				}
				if ( ( rel_file = fopen( rel_name, "w" ) ) == NULL ) {
	 				char temp_line[MAXLINE] = "cant open for writing ";
					( void ) strcat( temp_line, rel_name );
					on_error( temp_line, 0, FILEH );
				}
			} else { 
				char list_name[] = "/dev/null";

				if (( obj_file = fopen ( list_name, "w" )) == NULL ) {
					char temp_line[MAXLINE] = "cant open /dev/null for writing ";
					on_error( temp_line, 0, FILEH );
				}
				rel_file = obj_file;
			}

			if ( srec_state == FULL ) {

				strcpy( srec_name, name );
				strcat( srec_name, srecfix );

				if (( srec_file = fopen ( srec_name, "w" )) == NULL ) {
				
	 				char temp_line[MAXLINE] = "cant open for writing ";
					( void ) strcat( temp_line, srec_name );
					on_error( temp_line, 0, FILEH );
				}
			}
		}

	} else { 

		/* for testing purposes this allows zues to take its input from stdin 
		   this feature will be taken out from the 'live' version */
/*
		printf("taking input from stdin\n");
		list_file = fopen( ".list", "w" );
		obj_file = fopen( ".zobj", "w" );
		srec_file = fopen( srecfix, "w" );
*/
		on_error( "No source file specified", 0, HALT );
	}
	yyparse();
	(void) fclose( list_file );
	(void) fclose( obj_file );
	if ( srec_state == FULL ) {
		(void) fclose( srec_file );
	}

	/* Remove the temporary file */

	(void) unlink( tmp_file );

	return( VALID );
}

/* yyerror:	this function is required by yacc but is not really used in zues
		and therefore simply returns VALID */

int yyerror( char *s )
{
	return VALID; 
}

int on_error( char error[], int at_line, int type)
{
	extern int next_action;
	extern int obj_state;
	extern int num_passes;
	extern int last_line;

	extern	char	curr_file[];

	extern FILE *list_file;

	char state[ MAXLINE ];

	if ( assem_state == FIRST_PASS ){

		if ( num_passes == 1 ) {
			(void) strcpy( state, "prep:" );
		} else {
			type = INVALID;
		}

	} else if ( assem_state == SECOND_PASS ) {
		fprintf( list_file, "**> " );
		(void) strcpy( state, "" );
	}

	if ( last_line == at_line ) {
		type = INVALID;
	} else {
		last_line = at_line;
	}

	switch ( type ) {
		case SYNTAX : {
				(void) fprintf( stderr, "zues:%s syntax error in %s at line %d: %s\n",state, curr_file, at_line, error );
				if ( obj_state == FULL ) {
					(void) fprintf ( stderr, "zues:%s no object file will be produced...\n",state, at_line, error );
					obj_state = NO_OUTPUT;
				}
				
			}
			break;
		case SYSTEM : {
				(void) fprintf( stderr, "zues:%s system error in %s at line %d: %s\nzues:%s cannot continue, halting assembler...\n",state, curr_file, at_line, error, state );
			next_action = STOP; 
			}
			break;
		case LABEL : {
				(void) fprintf( stderr, "zues:%s syntax error in %s at line %d: %s\n",state, curr_file, at_line, error );
			}
			break;
		case FILEH : {
				(void) fprintf( stderr, "zues:%s file handling error: %s\n",state, error );
				next_action = STOP;
			}
			break;

		case WARN : 
		{
			if ( ( assem_state == SECOND_PASS ) && ( num_passes == 1 ) ) {
				(void) fprintf( stderr, "zues:%s warning in %s at line %d: %s\n", state, curr_file, at_line, error );
			}

			break;
		}

		case ADDR :
		case EXPR : {
				(void) fprintf( stderr, "zues:%s expression error in %s at line %d: %s\n", state, curr_file, at_line, error );
			}
			break;

		case HALT : {
				(void) fprintf( stderr, "zues: %s\n", error );
				next_action = QUIT;
			}
			break;
		case FINAL : {  
				if ( assem_state == SECOND_PASS ) {
					(void) fprintf( stderr, "zues:%s error in %s at line %d: %s\n", state, curr_file, at_line, error );
					(void) fprintf( stderr, "zues: the object file will be incorrect\n" );
					next_action = STOP;
				}
			}
			break;

		default : 	
		{

			break;
		}
	}

	check_status( at_line );
	return next_action;
}

int check_status( int at_line )
{
	extern int next_action;
	extern int diag_state;

	if ( next_action == STOP ){
		fprintf( stderr, "stopped at line %d\n", at_line );
		if ( diag_state == FULL )
			(void) dump_table( VALID, stderr );

		exit( 1 );
	} else if ( next_action == QUIT ){

		if ( diag_state == FULL )
			(void) dump_table( VALID, stderr );
	
		exit( 0 );
	} else
		return VALID;
}	
