/* ZUES Assembler source file -------------------------------*/

/* ######################################### 
   #                                         
   # (C) JPG 1993	opcode.c                  
   #                                         
   # Version 1.5			     
   #                                         
   # Updated 98/11/19 at 19:27:50                                 
   #                                        
   # ident @(#)opcode.c	1.5 		     		     
   # 
   # This program is free software; you can redistribute it and/or modify
   # it under the terms of the GNU General Public License as published by
   # the Free Software Foundation; either version 2 of the License, or
   # (at your option) any later version.
   #
   # This program is distributed in the hope that it will be useful,
   # but WITHOUT ANY WARRANTY; without even the implied warranty of
   # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   # GNU General Public License for more details.
   #
   # You should have received a copy of the GNU General Public License
   # along with this program; if not, write to the Free Software
   # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   #                                        
   ######################################### */

/* include header files here		> */

#include "opcode.h"

/* source starts here			> */

int op_gen( int num, int top1, int top2, int sop1, int sop2, int *offset, int address, int linenum )
{
	extern int diag_state;
	extern int assem_state;

	extern int addr_resolve;
	extern int addr_resolve_line;
	extern int zero_len_expr;

	int index = 0, pop_result = VALID, return_result = INVALID, length, new_op_data[5], prev_result = VALID ;
	int temp_num, is_an_expr;

	char inst[ MAXLINE ], op1[ MAXLINE ] = "\0", op2[ MAXLINE ] = "\0";

	if ( diag_state == FULL )  
		printf( "**op_gen starts:**\n");

	is_an_expr = ( ( top1 == i_e_ ) || ( top1 == e_ ) || ( top1 == E_ ) || ( top2 == i_e_ ) || ( top2 == e_ ) || ( top2 == E_ ) ) ? VALID : INVALID;
	if ( is_an_expr == VALID ) {
		print_stack( linenum );
		(void) invert_stack( linenum );
		print_stack( linenum );
	}

	if ( num == 3 ) {

		pop_result = pop_text( op2 );
		pop_result = ( ( pop_text( op1 ) == VALID ) && ( pop_result == VALID ) ) ? VALID : INVALID ; 

	} else if ( num == 2 ) {	

		if ( ( top1 != e_ ) && ( top1 != E_ ) ) {
			pop_result = pop_text( op1 );
		} else {
			pop_result = pop_text( op2 );
		}
	}

	if ( ( pop_text( inst ) == VALID ) && ( pop_result == VALID ) ) {
	
		for ( index = 0 ; index <= op_codes ; index++ ) {

			if ( is_an_expr == VALID ) {
				(void) save_stack( linenum );
			}

			if ( ( strcmp ( inst, op_data[ index ].instr ) == 0 ) && ( top1 == op_data[ index ].t_op_1 ) && ( top2 == op_data[ index ].t_op_2 ) ) {
			
				(void) op_dcopy( op_data[ index ].bytes, new_op_data, op_data[ index ].len);
				if ( op_data[ index ].s_op_1 != NSEQ ) {

					int position = op_data[ index ].byte_op_1;
					prev_result = op_scan ( position, new_op_data, op1, top1, op_data[ index ].s_op_1, linenum, address, op_data[ index ].op_1 ); 
					length = op_data[ index ].len;

					if ( prev_result == VALID ) {
						if ( op_data[ index ].t_op_1 == i_e_ ) {
							prev_result = ( strcmp ( op1, op_data[ index ].op_1 ) == 0 ) ? VALID : INVALID;
						}  
					}	
	
				} else if ( strcmp( op_data[ index ].op_1,  op1 ) == 0 ) {
					prev_result = VALID;
				} else {
					prev_result = INVALID;
				}

				if ( ( op_data[ index ].s_op_2 != NSEQ ) && ( prev_result == VALID ) ) {
					
					int position = op_data[ index ].byte_op_2;
					
					return_result = op_scan ( position, new_op_data, op2, top2, op_data[ index ].s_op_2, linenum, address, op_data[ index ].op_2 ); 
					length = op_data[ index ].len;

					if ( op_data[ index ].t_op_2 == i_e_ ) {
						return_result = ( strcmp ( op2, op_data[ index ].op_2 ) == 0 ) ? VALID : INVALID;
					}  
	
					if ( return_result == VALID ) 
						break;
	
				} else if ( ( op_data[ index ].s_op_2 == NSEQ ) && ( prev_result == VALID ) && ( strcmp( op_data[ index ].op_2, op2 ) == 0 ) ) {
					return_result = VALID;
					break;
				} else {
					/* modified for testing so as not to report missing opcodes */
					return_result = VALID;
				}

			/* modified for testing so as not to report missing opcodes */
				length = 0;
			 	return_result = VALID;
			}

			if ( is_an_expr == VALID ) {
				(void) recover_stack( linenum );
			}
	
		}

		/* modified 1/6/94 for generation of PIC code */

		if ( ( assem_state == SECOND_PASS ) && ( return_result == VALID ) && ( addr_resolve == VALID ) ) {

			extern struct addr_name_list *addr_names;

			addr_resolve = INVALID;

			if ( addr_resolve_line != linenum ) { 
				on_error( "line numbers dont match", linenum, WARN );
			}

			if ( ( op_data[ index ].s_op_1 != RBYTE ) && ( op_data[ index ].s_op_2 != RBYTE ) ) {
				(void) calc_addr_names( addr_names, address, op_data[ index ].t_op_1, op_data[ index ].t_op_2, op_data[ index ].byte_op_1, op_data[ index ].byte_op_2, op_data[ index ].len );

			}

			addr_names = (struct addr_name_list *) clear_name_list( addr_names );

		}

		(void) clear_stacks( &temp_num );	
		if ( return_result != VALID ){
			length = 0;
			
		} else {
			length = op_data[ index ].len;
		}
			
		if ( ( return_result == VALID ) && ( assem_state == SECOND_PASS ) ){
			list_gen( new_op_data, linenum, length, address );
		}
	
		*offset = length;

	}

	if ( length == 0 && return_result == VALID ) {

		zero_len_expr = INVALID;

	}

	if ( diag_state == FULL ) 
		printf( "**op_gen ends:**\n\n");

	return return_result;
}		

int op_scan( int position, int codes[], char op[],  int type_op, int seq_op, int linenum, int address, char op_str[] )
{
	extern int diag_state;
	extern int assem_state;

	int count = 0, new_byte = 0, return_result = INVALID;
	int byte = codes[ position ];
	
	if ( diag_state == FULL ) 
		printf( "**op_scan starts:**\n");

	switch ( seq_op ) {
	case SREGSEQ1 : {
		while ( count < n_sregseq1 ) {
			if ( ( strcmp ( op, d_sregseq1[ count ] ) ) == 0 ) {
				break;
			}
			count++;
		}
		if ( count > n_sregseq1 ) 
			return_result = INVALID;
		else {
			codes[ position ]=( count * b_sregseq1 ) + byte;
			return_result = VALID;
		}
		}
		break;
	case SREGSEQ2 : {
		count = 0;
		while ( count < n_sregseq2 ) {
			if ( ( strcmp( op, d_sregseq2[ count ] ) == 0 )) {
				break;
			}
			count++;
		}
		if ( count >= n_sregseq2 ) 
			return_result = INVALID;
		else {
			codes[ position ]=( count * b_sregseq2 ) + byte;
			return_result = VALID;

		}
		}
		break;
	case DREGSEQ1 : {
		while ( count <= n_dregseq1 ) {
			if ( ( strcmp ( op, d_dregseq1[ count ] ) ) == 0 ) {
				break;
			}
			count++;
		}
		if ( count >= n_dregseq1 ) 
			return_result = INVALID;
		else {
			codes[ position ]=( count * b_dregseq1 ) + byte;
			return_result = VALID;

		}
		}
		break;
	case DREGSEQ2: {
		while ( count <= n_dregseq2 ) {
			if ( ( strcmp ( op, d_dregseq2[ count ] ) ) == 0 ) {
				break;
			}
			count++;
		}
		if ( count > n_dregseq2 ) 
			return_result = INVALID;
		else {
			codes[ position ]=( count * b_dregseq2 ) + byte;
			return_result = VALID;

		}
		}
		break;
	case FSEQ1 : {
		while ( count <= n_fseq1 ) {
			if ( ( strcmp ( op, d_fseq1[ count ] ) ) == 0 ) {
				break;
			}
			count++;
		}
		if ( count > n_fseq1 ) 
			return_result = INVALID;
		else {
			codes[ position ] = ( count * b_fseq1 ) + byte;
			return_result = VALID;

		}
		}
		break;
	case FSEQ2 : {
		while ( count <= n_fseq2 ) {
			if ( ( strcmp ( op, d_fseq2[ count ] ) ) == 0 ) {
				break;
			}
			count++;
		}
		if ( count > n_fseq2 ) {
			return_result = INVALID;
		} else {
			codes[ position ] = ( count * b_fseq2 ) + byte;
			return_result = VALID;

		}
	
		}
		break;
	case BSEQ1 : {
		int temp_expr;
		count = 0;
		if ( pop( &temp_expr ) == VALID ) {
			while ( count < n_bseq1 ) {
				if ( temp_expr == d_bseq1[ count ] ) {

					break;
				}
				count++;
			}
			if ( count >= n_bseq1 ) {
				on_error( "error in bit expression", linenum, EXPR );
				return_result = INVALID;
			} else {

				codes[ position ] = ( count * b_bseq1 ) + byte;
				return_result = VALID;


			}

		} else {
			return_result = INVALID;                
		}
		}
		break;
	case BSEQ2 : {
		int temp_expr;
	
		if ( pop( &temp_expr ) == VALID ) {

			while ( count < n_bseq2 ) {
				if ( temp_expr == d_bseq2[ count ] ) {

					break;
				}
				count++;
			}
			if ( count >= n_bseq2 ) {
				on_error( "error in bit expression", linenum, EXPR );
				return_result = INVALID;
			} else {

				codes[ position ] = ( count * b_bseq2 ) + byte;
				return_result = VALID;


			}

		} else {
			return_result = INVALID;                
		}
		}
		break;
	
	case ABYTE : {
		int temp_expr;

		if ( pop( &temp_expr ) == VALID ) {
			if ( ( temp_expr <= MAX_ABYTE ) && ( temp_expr >= MIN_ABYTE ) ) {
				codes[ position ] = ( temp_expr + byte );
				return_result = VALID;
			} else {
				on_error( "expression out of bounds", linenum, EXPR );
				return_result = VALID;
			}
		} else if ( assem_state == SECOND_PASS ) {
			on_error( "missing expression", linenum, EXPR );
			return_result = INVALID;
		} else
			return_result = VALID;
		}
		break; 
	case SBYTE :
		break;
	case RBYTE : {
		extern mem_expr;
		int temp_expr; 
		unsigned int new_temp_expr;


		if ( pop( &temp_expr ) == VALID ) {
			if ( mem_expr == VALID ) {
				temp_expr = temp_expr - ( address + 2 );
			} else {
				temp_expr = temp_expr - 2;
			}
			if ( ( temp_expr >= MAX_RBYTE ) || ( temp_expr <= MIN_RBYTE ) ) {
				on_error( "expression out of bounds", linenum, EXPR );
				return_result = INVALID;

			} else {
				if ( temp_expr < 0 ) {
					new_temp_expr = -1 * temp_expr;
					new_temp_expr = 255 & ( ( ~ new_temp_expr ) + 1 );
				} else
					new_temp_expr = temp_expr;

				codes[ position ] = ( new_temp_expr + byte );
				return_result = VALID;
			}				
			
		} else if ( assem_state == SECOND_PASS ) {
			on_error( "missing expression", linenum, EXPR );
			return_result = INVALID;
		} else 
			return_result = VALID;	
		}
		break;
	case AWORD : {
		int temp_expr;

		if ( pop( &temp_expr ) == VALID ) {
			if ( ( temp_expr <= MAX_AWORD ) ) {
				int bytes[ 2 ];

				if ( temp_expr < 0 ) {

					temp_expr = 65536 + temp_expr;

				}

				if ( one_two_l( temp_expr, bytes, 2 ) == VALID ) { 
					codes[ position ] = ( bytes[ 0 ] + byte );
					codes[ position + 1 ] = ( bytes[ 1 ] );
					return_result = VALID;
				} else {
					return_result = INVALID;
				}
			} else {
				on_error( "word expression out of bounds", linenum, EXPR );
				return_result = INVALID;
			}
		} else if ( assem_state == SECOND_PASS ) {
			on_error( "missing expression", linenum, EXPR );
			return_result = INVALID;
		}
		}
		break;
	case SWORD :
		break;
	case RWORD :
		break;
	case ALONG :
		break;
	case SLONG :
		break;
	case RLONG :
		break;
	case NUMSEQ : {
		int temp_num, temp_num2;


		if ( pop( &temp_num ) == VALID ) {
			temp_num2 = (int) atoi( op_str );
			if ( temp_num == temp_num2 ){
				return_result = VALID;
			} else {
				push( temp_num, linenum );
				return_result = INVALID;
			}
		}
		}
		break;	
	default:
		break;
	}
	if ( diag_state == FULL ) 
		printf( "**op_scan ends:**\n\n");

	return return_result;
}

/* op_dcopy:	function to copy an array of integers from one byte
		sequnce array to a new one. Always returns valid */

int op_dcopy( int old_copy[], int new_copy[], int len )
{
	extern int diag_state;
	int index;

	if ( diag_state == FULL ) 
		printf( "**op_dcopy starts:**\n");

	for ( index=0; index <= len; index++ ) {
		new_copy[ index ] = old_copy[ index ];
	}

	if ( diag_state == FULL ) 
		printf( "**op_dcopy ends:**\n\n");

	return VALID;
}

/* one_two_l:	convert a word to two bytes, low order byte first &
		higher order byte second */

int one_two_l( int number, int bytes[], int max_len )
{
	int return_result = VALID;
	int index = 0;

	bytes[ 0 ] = number % 256;
	bytes[ 1 ] = number / 256;

	if ( ( bytes[ index ] < 256 ) && ( return_result != INVALID ) ) {
		return_result = VALID;
	} else {
		return_result = INVALID;
	}
	return return_result;
}	


