/* ZUES Assembler header file ---------------------------------*/

/* ######################################### 
   #                                         
   # (C) JPG 1993	opcode.h                  
   #                                         
   # Version 1.4			     
   #                                         
   # Updated 98/11/19 at 19:27:49                                 
   #                                        
   # ident @(#)opcode.h	1.4 		     		     
   #                                        
   ######################################### */

/* include standard librarys here		> */

#include <stdio.h>
#include <string.h>

/* include globally defined variables and definitions here > */

#include "global.h"

/* define local definitions here		> */

#define  MAXOPS 5000

/* define local global variables here		> */

struct statem {			/* each operator has an instruction */
	char instr[MAXLINE];    /* string possibly two following   */
	char op_1[MAXLINE];	/* operator strings, two operator    */
	char op_2[MAXLINE];     /* types and a qualifier for each  */
	int t_op_1;		/* It also contains the lengths    */
	int t_op_2;		/* the byte sequence and the 	   */
	int s_op_1;		/* modifier position for each	   */
	int s_op_2;		/* operator if applicable	   */
	int len;
	int bytes[5];
	int byte_op_1;
	int byte_op_2;
};

static struct statem op_data[] = {
{ "adc", "a", "", r_, e_, NSEQ, ABYTE, 2, { 206, 0 }, 0, 1 },
{ "adc", "a", "", r_, r_, NSEQ, SREGSEQ2, 1, { 136 }, 0 },
{ "adc", "a", "hl", r_, RR_, NSEQ, NSEQ, 1, { 142 }, 0 },
{ "adc", "a", "ix", r_, i_e_, NSEQ, ABYTE, 3, { 221, 142, 0 }, 0, 2 },
{ "adc", "a", "iy", r_, i_e_, NSEQ, ABYTE, 3, { 253, 142, 0 }, 0, 2 },
{ "adc", "hl", "", rr_, rr_, NSEQ, DREGSEQ2, 2, { 237, 74 }, 0, 1 },
{ "add", "a", "", r_, e_, NSEQ, ABYTE, 2, { 198, 0 }, 0, 1 },
{ "add", "a", "", r_, r_, NSEQ, SREGSEQ2, 1, { 128 }, 0 },
{ "add", "a", "hl", r_, RR_, NSEQ, NSEQ, 1, { 134 }, 0 },
{ "add", "a", "ix", r_, i_e_, NSEQ, ABYTE, 3, { 221, 134, 0 }, 0, 2 },
{ "add", "a", "iy", r_, i_e_, NSEQ, ABYTE, 3, { 253, 134, 0 }, 0, 2 },
{ "add", "hl", "", rr_, rr_, NSEQ, DREGSEQ2, 1, { 9 }, 0 },
{ "add", "ix", "bc", i_, rr_, NSEQ, NSEQ, 2, { 221, 9 }, 0, 0 },
{ "add", "iy", "bc", i_, rr_, NSEQ, NSEQ, 2, { 253, 9 }, 0, 0 },
{ "add", "ix", "de", i_, rr_, NSEQ, NSEQ, 2, { 221, 25 }, 0, 0 },
{ "add", "iy", "de", i_, rr_, NSEQ, NSEQ, 2, { 253, 25 }, 0, 0 },
{ "add", "ix", "ix", i_, i_, NSEQ, NSEQ, 2, { 221, 41 }, 0, 0 },
{ "add", "iy", "iy", i_, i_, NSEQ, NSEQ, 2, { 253, 41 }, 0, 0 },
{ "add", "ix", "sp", i_, rr_, NSEQ, NSEQ, 2, { 221, 57 }, 0, 0 },
{ "add", "iy", "sp", i_, rr_, NSEQ, NSEQ, 2, { 253, 57 }, 0, 0 },
{ "and", "", "", e_, NON, ABYTE, NSEQ, 2, { 230, 0 }, 1 },
{ "and", "", "", r_, NON, SREGSEQ2, NSEQ, 1, { 160 }, 0 },
{ "and", "hl", "", RR_, NON, NSEQ, NSEQ, 1, { 166 }, 0, 0 },
{ "and", "ix", "", i_e_, NON, ABYTE, NSEQ, 3, { 221, 166, 0 }, 2, 0 },
{ "and", "iy", "", i_e_, NON, ABYTE, NSEQ, 3, { 253, 166, 0 }, 2, 0 },
{ "bit", "", "", e_, r_, BSEQ1, SREGSEQ2, 2, { 203, 64 }, 1, 1 },
{ "bit", "", "hl", e_, RR_, BSEQ1, NSEQ, 2, { 203, 70 }, 1 },
{ "bit", "", "ix", e_, i_e_, BSEQ1, ABYTE, 4, { 221, 203, 0, 70 }, 3, 2 },
{ "bit", "", "iy", e_, i_e_, BSEQ1, ABYTE, 4, { 253, 203, 0, 70 }, 3, 2 },
{ "call", "", "", e_, NON, AWORD, NSEQ, 3, { 205, 0, 0 }, 1 },
{ "call", "", "", f_, e_, FSEQ1, AWORD, 3, { 196, 0, 0 }, 0, 1 },
{ "ccf", "", "", NON, NON, NSEQ, NSEQ, 1, { 63 }, 0, 0 },
{ "cp", "", "", e_, NON, ABYTE, NSEQ, 2, { 254 }, 1, 0 },
{ "cp", "", "", r_, NON, SREGSEQ2, NSEQ, 1, { 184 }, 0, 0 },
{ "cp", "hl", "", RR_, NON, NSEQ, NSEQ, 1, { 190 }, 0, 0 },
{ "cp", "ix", "", i_e_, NON, ABYTE, NSEQ, 3, { 221, 190, 0 }, 2, 0 },
{ "cp", "iy", "", i_e_, NON, ABYTE, NSEQ, 3, { 253, 190, 0 }, 2, 0 },
{ "cpd", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 169 }, 0, 0 },
{ "cpdr", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 185 }, 0, 0 },
{ "cpi", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 161 }, 0, 0 },
{ "cpir", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 177 }, 0, 0 },
{ "cpl", "", "", NON, NON, NSEQ, NSEQ, 1, { 47 }, 0, 0 },
{ "daa", "", "", NON, NON, NSEQ, NSEQ, 1, { 39 }, 0, 0 },
{ "dec", "", "", r_, NON, SREGSEQ1, NSEQ, 1, { 5 }, 0, 0 },
{ "dec", "hl", "", RR_, NON, NSEQ, NSEQ, 1, { 53 }, 0, 0 },
{ "dec", "ix", "", i_e_, NON, ABYTE, NSEQ, 3, { 221, 53, 0 }, 2, 0 },
{ "dec", "iy", "", i_e_, NON, ABYTE, NSEQ, 3, { 253, 53, 0 }, 2, 0 },
{ "dec", "", "", rr_, NON, DREGSEQ2, NSEQ, 1, { 11 }, 0, 0 },
{ "dec", "ix", "", i_, NON, NSEQ, NSEQ, 2, { 221, 43 }, 0, 0 },
{ "dec", "iy", "", i_, NON, NSEQ, NSEQ, 2, { 253, 43 }, 0, 0 },
{ "di", "", "", NON, NON, NSEQ, NSEQ, 1, { 243 }, 0, 0 },
{ "djnz", "", "", e_, NON, RBYTE, NSEQ, 2, { 16, 0 }, 1, 0 },
{ "ei", "", "", NON, NON, NSEQ, NSEQ, 1, { 251 }, 0, 0 },
{ "ex", "af", "af'", rr_, rr_b_, NSEQ, NSEQ, 1, { 8 }, 0, 0 },
{ "ex", "de", "hl", rr_, rr_, NSEQ, NSEQ, 1, { 235 }, 0, 0 },
{ "ex", "sp", "hl", RR_, rr_, NSEQ, NSEQ, 1, { 227 }, 0, 0 },
{ "ex", "sp", "ix", RR_, i_, NSEQ, NSEQ, 2, { 221, 227 }, 0, 0 },
{ "ex", "sp", "iy", RR_, i_, NSEQ, NSEQ, 2, { 253, 227 }, 0, 0 },
{ "exx", "", "", NON, NON, NSEQ, NSEQ, 1, { 217 }, 0, 0 },
{ "halt", "", "", NON, NON, NSEQ, NSEQ, 1, { 118 }, 0, 0 },
{ "im", "0", "", e_, NON, NUMSEQ, NSEQ, 2, { 237, 70 }, 0, 0 },
{ "im", "1", "", e_, NON, NUMSEQ, NSEQ, 2, { 237, 86 }, 0, 0 },
{ "im", "2", "", e_, NON, NUMSEQ, NSEQ, 2, { 237, 94 }, 0, 0 },
{ "in", "a", "", r_, E_, NSEQ, ABYTE, 2, { 219, 0 }, 0, 1 },
{ "in", "", "c", r_, R_, SREGSEQ1, NSEQ, 2, { 237, 64 }, 1, 0 },
{ "inc", "", "", r_, NON, SREGSEQ1, NSEQ, 1, { 4 }, 0, 0 },
{ "inc", "", "", rr_, NON, DREGSEQ2, NSEQ, 1, { 3 }, 0, 0 },
{ "inc", "hl", "", RR_, NON, NSEQ, NSEQ, 1, { 52 }, 0, 0 },
{ "inc", "ix", "", i_e_, NON, ABYTE, NSEQ, 3, { 221, 52, 0 }, 2, 0 },
{ "inc", "iy", "", i_e_, NON, ABYTE, NSEQ, 3, { 253, 52, 0 }, 2, 0 },
{ "inc", "ix", "", i_, NON, NSEQ, NSEQ, 2, { 221, 35 }, 0, 0 },
{ "inc", "iy", "", i_, NON, NSEQ, NSEQ, 2, { 253, 35 }, 0, 0 },
{ "ind", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 170 }, 0, 0 },
{ "indr", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 186 }, 0, 0 },
{ "ini", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 162 }, 0, 0 },
{ "inir", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 178 }, 0, 0 },
{ "jp", "", "", e_, NON, AWORD, NSEQ, 3, { 195, 0, 0 }, 1, 0 },
{ "jp", "hl", "", RR_, NON, NSEQ, NSEQ, 1, { 233 }, 0, 0 },
{ "jp", "ix", "", I_, NON, NSEQ, NSEQ, 2, { 221, 233 }, 0, 0 },
{ "jp", "iy", "", I_, NON, NSEQ, NSEQ, 2, { 253, 233 }, 0, 0 },
{ "jp", "", "", f_, e_, FSEQ1, AWORD, 3, { 194, 0, 0 }, 0, 1 },
{ "jr", "", "", e_, NON, RBYTE, NSEQ, 2, { 24, 0 }, 1, 0 },
{ "jr", "", "", f_, e_, FSEQ2, RBYTE, 2, { 32, 0 }, 0, 1 },
{ "ld", "a", "i", r_, r_, NSEQ, NSEQ, 2, { 237, 87 }, 0, 0 },
{ "ld", "a", "r", r_, r_, NSEQ, NSEQ, 2, { 237, 95 }, 0, 0 },
{ "ld", "i", "a", r_, r_, NSEQ, NSEQ, 2, { 237, 71 }, 0, 0 },
{ "ld", "r", "a", r_, r_, NSEQ, NSEQ, 2, { 237, 79 }, 0, 0 },
{ "ld", "a", "", r_, E_, NSEQ, AWORD, 3, { 58, 0, 0 }, 0, 1 },
{ "ld", "a", "bc", r_, RR_, NSEQ, NSEQ, 1, { 10 }, 0, 0 },
{ "ld", "a", "de", r_, RR_, NSEQ, NSEQ, 1, { 26 }, 0, 0 },
{ "ld", "", "", r_, e_, SREGSEQ1, ABYTE, 2, { 6, 0 }, 0, 1 },
{ "ld", "", "", r_, r_, SREGSEQ1, SREGSEQ2, 1, { 64 }, 0, 0 },
{ "ld", "", "hl", r_, RR_, SREGSEQ1, NSEQ, 1, { 70 }, 0, 0 },
{ "ld", "", "ix", r_, i_e_, SREGSEQ1, ABYTE, 3, { 221, 70, 0 }, 1, 2 },
{ "ld", "", "iy", r_, i_e_, SREGSEQ1, ABYTE, 3, { 253, 70, 0 }, 1, 2 },
{ "ld", "", "", rr_, e_, DREGSEQ2, AWORD, 3, { 1, 0, 0 }, 0, 1 },
{ "ld", "ix", "", i_, e_, NSEQ, AWORD, 4, { 221, 33, 0, 0 }, 0, 2 },
{ "ld", "iy", "", i_, e_, NSEQ, AWORD, 4, { 253, 33, 0, 0 }, 0, 2 },
{ "ld", "", "", rr_, E_, DREGSEQ2, AWORD, 4, { 237, 75, 0, 0 }, 1, 2 },
{ "ld", "ix", "", i_, E_, NSEQ, AWORD, 4, { 221, 42, 0, 0 }, 0, 2 },
{ "ld", "iy", "", i_, E_, NSEQ, AWORD, 4, { 253, 42, 0, 0 }, 0, 2 },
{ "ld", "sp", "hl", rr_, rr_, NSEQ, NSEQ, 1, { 249 }, 0, 0 },
{ "ld", "sp", "ix", rr_, i_, NSEQ, NSEQ, 2, { 221, 249 }, 0, 0 },
{ "ld", "sp", "iy", rr_, i_, NSEQ, NSEQ, 2, { 253, 249 }, 0, 0 },
{ "ld", "", "a", E_, r_, AWORD, NSEQ, 3, { 50, 0, 0 }, 1, 0 },
{ "ld", "", "", E_, rr_, AWORD, DREGSEQ2, 4, { 237, 67, 0, 0 }, 2, 1 },
{ "ld", "", "ix", E_, i_, AWORD, NSEQ, 4, { 221, 34, 0, 0 }, 2, 0 },
{ "ld", "", "iy", E_, i_, AWORD, NSEQ, 4, { 253, 34, 0, 0 }, 2, 0 },
{ "ld", "bc", "a", RR_, r_, NSEQ, NSEQ, 1, { 2 }, 0, 0 },
{ "ld", "de", "a", RR_, r_, NSEQ, NSEQ, 1, { 18 }, 0, 0 },
{ "ld", "hl", "", RR_, e_, NSEQ, ABYTE, 2, { 54, 0 }, 0, 1 },
{ "ld", "hl", "", RR_, r_, NSEQ, SREGSEQ2, 1, { 112 }, 0, 0 },
{ "ld", "ix", "", i_e_, e_, ABYTE, ABYTE, 4, { 221, 54, 0, 0 }, 2, 3 },
{ "ld", "iy", "", i_e_, e_, ABYTE, ABYTE, 4, { 253, 54, 0, 0 }, 2, 3 },
{ "ld", "ix", "", i_e_, r_, ABYTE, SREGSEQ2, 3, { 221, 112, 0 }, 2, 1 },
{ "ld", "iy", "", i_e_, r_, ABYTE, SREGSEQ2, 3, { 253, 112, 0 }, 2, 1 },
{ "ldd", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 168 }, 0, 0 },
{ "lddr", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 184 }, 0, 0 },
{ "ldi", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 160 }, 0, 0 },
{ "ldir", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 176 }, 0, 0 },
{ "neg", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 68 }, 0, 0 },
{ "nop", "", "", NON, NON, NSEQ, NSEQ, 1, { 0 }, 0, 0 },
/* got here on 8/1/93 */
{ "or", "", "", e_, NON, ABYTE, NSEQ, 2, { 246, 0 }, 1, 0 },
{ "or", "", "", r_, NON, SREGSEQ2, NSEQ, 1, { 176 }, 0, 0 },
{ "or", "hl", "", RR_, NON, NSEQ, NSEQ, 1, { 182 }, 0, 0 },
{ "or", "ix", "", i_e_, NON, ABYTE, NSEQ, 3, { 221, 182, 0 }, 2, 0 },
{ "or", "iy", "", i_e_, NON, ABYTE, NSEQ, 3, { 253, 182, 0 }, 2, 0 },
{ "otdr", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 187 }, 0, 0 },
{ "otir", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 179 }, 0, 0 },
{ "out", "c", "", R_, r_, NSEQ, SREGSEQ1, 2, { 237, 65 }, 0, 1 },
{ "out", "", "a", E_, r_, ABYTE, NSEQ, 2, { 211, 0 }, 1, 0 },
{ "outd", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 171 }, 0, 0 },
{ "outi", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 163 }, 0, 0 },
{ "pop", "", "", rr_, NON, DREGSEQ1, NSEQ, 1, { 193 }, 0, 0 },
{ "pop", "ix", "", i_, NON, NSEQ, NSEQ, 2, { 221, 225 }, 0, 0 },
{ "pop", "iy", "", i_, NON, NSEQ, NSEQ, 2, { 253, 225 }, 0, 0 },
{ "push", "", "", rr_, NON, DREGSEQ1, NSEQ, 1, { 197 }, 0, 0 },
{ "push", "ix", "", i_, NON, NSEQ, NSEQ, 2, { 221, 229 }, 0, 0 },
{ "push", "iy", "", i_, NON, NSEQ, NSEQ, 2, { 253, 229 }, 0, 0 },
{ "res", "", "", e_, r_, BSEQ1, SREGSEQ2, 2, { 203, 128 }, 1, 1 },
{ "res", "", "hl", e_, RR_, BSEQ1, NSEQ, 2, { 203, 134 }, 1, 0 },
{ "res", "", "ix", e_, i_e_, BSEQ1, ABYTE, 4, { 221, 203, 0, 134 }, 3, 2 },
{ "res", "", "iy", e_, i_e_, BSEQ1, ABYTE, 4, { 253, 203, 0, 134 }, 3, 2 },
{ "ret", "", "", NON, NON, NSEQ, NSEQ, 1, { 201 }, 0, 0 },
{ "ret", "", "", f_, NON, FSEQ1, NSEQ, 1, { 192 }, 0, 0 },
{ "reti", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 77 }, 0, 0 },
{ "retn", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 69 }, 0, 0 },
{ "rl", "", "", r_, NON, SREGSEQ2, NSEQ, 2, { 203, 16 }, 1, 0 },
{ "rl", "hl", "", RR_, NON, NSEQ, NSEQ, 2, { 203, 22 }, 0, 0 },
{ "rl", "ix", "", i_e_, NON, ABYTE, NSEQ, 4, { 221, 203, 0, 22 }, 2, 0 },
{ "rl", "iy", "", i_e_, NON, ABYTE, NSEQ, 4, { 253, 203, 0, 22 }, 2, 0 },
{ "rla", "", "", NON, NON, NSEQ, NSEQ, 1, { 23 }, 0, 0 },
{ "rlc", "", "", r_, NON, SREGSEQ2, NSEQ, 2, { 203, 0 }, 1, 0 },
{ "rlc", "hl", "", RR_, NON, NSEQ, NSEQ, 2, { 203, 6 }, 0, 0 },
{ "rlc", "ix", "", i_e_, NON, ABYTE, NSEQ, 4, { 221, 203, 0, 6 }, 2, 0 },
{ "rlc", "iy", "", i_e_, NON, ABYTE, NSEQ, 4, { 253, 203, 0, 6 }, 2, 0 },
{ "rlca", "", "", NON, NON, NSEQ, NSEQ, 1, { 7 }, 0, 0 },
{ "rld", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 111 }, 0, 0 },
{ "rr", "", "", r_, NON, SREGSEQ2, NSEQ, 2, { 203, 24 }, 1, 0 },
{ "rr", "hl", "", RR_, NON, NSEQ, NSEQ, 2, { 203, 30 }, 0, 0 },
{ "rr", "ix", "", i_e_, NON, ABYTE, NSEQ, 4, { 221, 203, 0, 30 }, 2, 0 },
{ "rr", "iy", "", i_e_, NON, ABYTE, NSEQ, 4, { 253, 203, 0, 30 }, 2, 0 },
{ "rra", "", "", NON, NON, NSEQ, NSEQ, 1, { 31 }, 0, 0 },
{ "rrc", "", "", r_, NON, SREGSEQ2, NSEQ, 2, { 203, 8 }, 1, 0 },
{ "rrc", "hl", "", RR_, NON, NSEQ, NSEQ, 2, { 203, 14 }, 0, 0 },
{ "rrc", "ix", "", i_e_, NON, ABYTE, NSEQ, 4, { 221, 203, 0, 14 }, 2, 0 },
{ "rrc", "iy", "", i_e_, NON, ABYTE, NSEQ, 4, { 253, 203, 0, 14 }, 2, 0 },
{ "rrca", "", "", NON, NON, NSEQ, NSEQ, 1, { 15 }, 0, 0 },
{ "rrd", "", "", NON, NON, NSEQ, NSEQ, 2, { 237, 103 }, 0, 0 },
{ "rst", "0", "", e_, NON, NUMSEQ, NSEQ, 1, { 199 }, 0, 0 },
{ "rst", "8", "", e_, NON, NUMSEQ, NSEQ, 1, { 207 }, 0, 0 },
{ "rst", "16", "", e_, NON, NUMSEQ, NSEQ, 1, { 215 }, 0, 0 },
{ "rst", "24", "", e_, NON, NUMSEQ, NSEQ, 1, { 223 }, 0, 0 },
{ "rst", "32", "", e_, NON, NUMSEQ, NSEQ, 1, { 231 }, 0, 0 },
{ "rst", "40", "", e_, NON, NUMSEQ, NSEQ, 1, { 239 }, 0, 0 },
{ "rst", "48", "", e_, NON, NUMSEQ, NSEQ, 1, { 247 }, 0, 0 },
{ "rst", "56", "", e_, NON, NUMSEQ, NSEQ, 1, { 255 }, 0, 0 },
{ "sbc", "a", "", r_, e_, NSEQ, ABYTE, 2, { 222, 0 }, 0, 1 },
{ "sbc", "a", "", r_, r_, NSEQ, SREGSEQ2, 1, { 152 }, 0, 0 },
{ "sbc", "a", "hl", r_, RR_, NSEQ, NSEQ, 1, { 158 }, 0, 0 },
{ "sbc", "a", "ix", r_, i_e_, NSEQ, ABYTE, 3, { 221, 158, 0 }, 0, 2 },
{ "sbc", "a", "iy", r_, i_e_, NSEQ, ABYTE, 3, { 253, 158, 0 }, 0, 2 },
{ "sbc", "hl", "", rr_, rr_, NSEQ, DREGSEQ2, 2, { 237, 66 }, 0, 1 },
{ "scf", "", "", NON, NON, NSEQ, NSEQ, 1, { 55 }, 0, 0 },
{ "set", "", "", e_, r_, BSEQ1, SREGSEQ2, 2, { 203, 192 }, 1, 1 },
{ "set", "", "hl", e_, RR_, BSEQ1, NSEQ, 2, { 203, 198 }, 1, 0 },
{ "set", "", "ix", e_, i_e_, BSEQ1, ABYTE, 4, { 221, 203, 0, 198 }, 3, 2 },
{ "set", "", "iy", e_, i_e_, BSEQ1, ABYTE, 4, { 253, 203, 0, 198 }, 3, 2 },
{ "sla", "", "", r_, NON, SREGSEQ2, NSEQ, 2, { 203, 32 }, 1, 0 },
{ "sla", "hl", "", RR_, NON, NSEQ, NSEQ, 2, { 203, 38 }, 0, 0 },
{ "sla", "ix", "", i_e_, NON, ABYTE, NSEQ, 4, { 221, 203, 0, 38 }, 2, 0 },
{ "sla", "iy", "", i_e_, NON, ABYTE, NSEQ, 4, { 253, 203, 0, 38 }, 2, 0 },
{ "sra", "", "", r_, NON, SREGSEQ2, NSEQ, 2, { 203, 40 }, 1, 0 },
{ "sra", "hl", "", RR_, NON, NSEQ, NSEQ, 2, { 203, 46 }, 0, 0 },
{ "sra", "ix", "", i_e_, NON, ABYTE, NSEQ, 4, { 221, 203, 0, 46 }, 2, 0 },
{ "sra", "iy", "", i_e_, NON, ABYTE, NSEQ, 4, { 253, 203, 0, 46 }, 2, 0 },
{ "srl", "", "", r_, NON, SREGSEQ2, NSEQ, 2, { 203, 56 }, 1, 0 },
{ "srl", "hl", "", RR_, NON, NSEQ, NSEQ, 2, { 203, 62 }, 0, 0 },
{ "srl", "ix", "", i_e_, NON, ABYTE, NSEQ, 4, { 221, 203, 0, 62 }, 2, 0 },
{ "srl", "iy", "", i_e_, NON, ABYTE, NSEQ, 4, { 253, 203, 0, 62 }, 2, 0 },
{ "sub", "", "", e_, NON, ABYTE, NSEQ, 2, { 214, 0 }, 1, 0 },
{ "sub", "", "", r_, NON, SREGSEQ2, NSEQ, 1, { 144 }, 0, 0 },
{ "sub", "hl", "", RR_, NON, NSEQ, NSEQ, 1, { 150 }, 0, 0 },
{ "sub", "ix", "", i_e_, NON, ABYTE, NSEQ, 3, { 221, 150, 0 }, 2, 0 },
{ "sub", "iy", "", i_e_, NON, ABYTE, NSEQ, 3, { 253, 150, 0 }, 2, 0 },
{ "xor", "", "", e_, NON, ABYTE, NSEQ, 2, { 238, 0 }, 1, 0 },
{ "xor", "", "", r_, NON, SREGSEQ2, NSEQ, 1, { 168 }, 0, 0 },
{ "xor", "hl", "", RR_, NON, NSEQ, NSEQ, 1, { 174 }, 0, 0 },
{ "xor", "ix", "", i_e_, NON, ABYTE, NSEQ, 3, { 221, 174, 0 }, 2, 0 },
{ "xor", "iy", "", i_e_, NON, ABYTE, NSEQ, 3, { 253, 174, 0 }, 2, 0 },
};

static int op_codes = ( sizeof op_data / sizeof ( struct statem ) );

/* sequences are defined by listing their elements, 'void_' is       */
/* a convention to miss elements, n_<seq> is the number of elements, */
/* and b_<seq> is the number difference between elements             */

static char d_sregseq1[][MAXLINE] = { "b", "c", "d", "e", "h", "l","void_", "a" };
static int  n_sregseq1=8;
static int  b_sregseq1=8;

/* ------------------------------------- */

static char d_sregseq2[][MAXLINE] = { "b", "c", "d", "e", "h", "l","void_", "a" };
static int  n_sregseq2=8;
static int  b_sregseq2=1;

/* ------------------------------------- */

static int d_bseq1[] = { 0, 1, 2, 3, 4, 5, 6, 7 };

static int n_bseq1=8;
static int b_bseq1=8;

/* ------------------------------------- */

static int d_bseq2[] = { 0, 1, 2, 3, 4, 5, 6, 7 };

static int n_bseq2=8;
static int b_bseq2=2;

/* ------------------------------------- */

static char d_dregseq1[][MAXLINE] = { "bc", "de", "hl", "af" };

static int n_dregseq1 = 4;
static int b_dregseq1 = 16;

/* ------------------------------------- */

static char d_dregseq2[][MAXLINE] = { "bc", "de", "hl", "sp" };

static int n_dregseq2 = 4;
static int b_dregseq2 = 16;

/* ------------------------------------- */

static char d_fseq1[][MAXLINE] = { "nz", "z", "nc", "c", "po", "pe", "p", "m" };

static int n_fseq1 = 8;
static int b_fseq1 = 8;

/* ------------------------------------- */

static char d_fseq2[][MAXLINE] = { "nz", "z", "nc", "c" };

static int n_fseq2 = 4;
static int b_fseq2 = 8;

/* define global external variables here	> */

/* define global function definitions here      > */

/* define local function definitions here       > */
