/* ZUES Assembler source file -------------------------------*/

/* ######################################### 
   #                                         
   # (C) JPG 1993	resol.c                  
   #                                         
   # Version 1.4			     
   #                                         
   # Updated 98/11/19 at 19:27:51                                 
   #                                        
   # ident @(#)resol.c	1.4 		     		     
   # 
   # This program is free software; you can redistribute it and/or modify
   # it under the terms of the GNU General Public License as published by
   # the Free Software Foundation; either version 2 of the License, or
   # (at your option) any later version.
   #
   # This program is distributed in the hope that it will be useful,
   # but WITHOUT ANY WARRANTY; without even the implied warranty of
   # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   # GNU General Public License for more details.
   #
   # You should have received a copy of the GNU General Public License
   # along with this program; if not, write to the Free Software
   # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   #
   ######################################### */

/* include header files here		> */

#include "resol.h"

/* source starts here			> */

/* calcul: function to calculate an expression 
	   held in two stacks, an operator stack &
	   a number stack.  */

int calcul( int line_num )
{
	extern int diag_state;
	extern int brac_in;
	int first_num, second_num, result, return_result;
	char operator, temp_operator;

	if ( diag_state == FULL ) 
		printf( "**calcul starts:**\n");
	
	print_stack( line_num );
	print_op( line_num );
	if ( pop( &first_num ) == VALID ) { 
		if ( pop( &second_num ) == VALID ) {
			if ( pop_op ( &operator ) == VALID ) {

				if ( ( operator == '(' ) && ( brac_in == OUT ) ) {
					/* if operator is an open bracket and were not
					currently 'in' a bracket push everything back 
					onto the number and operator stacks */

					push_op( operator, line_num );
					push( second_num, line_num );
					push( first_num, line_num );

				} else if ( ( operator == '(' ) && ( brac_in == IN ) ) {
					/* if operator is an open bracket and were
					'in' a bracket, reset the bracket state and pop
					the next operator off the stack, which should
					be a valid operation */

					brac_in = OUT ;
					push( second_num, line_num );
					push( first_num, line_num );

				} else if ( ( operator == ')' ) ) {
					
					temp_operator = operator;
					pop_op( &operator );
					if ( operator != '(' ) {
						push_op( temp_operator, line_num );		
					} else {
						push( second_num, line_num );
						push( first_num, line_num );
					}

				}
				switch ( operator ) {
					case '+' : {
							result = second_num + first_num;
							return_result = push( result, line_num );
						}
						break;
					case '-' : {
							result = second_num - first_num;
							return_result = push( result, line_num );
						}
						break;
					case '*' : {
							result = second_num * first_num;
							return_result = push( result, line_num );
					
						}
						break;
					case '/': {	
							if ( first_num != 0 ) {
								result = second_num / first_num;
								return_result = push( result, line_num );
							} else {

								on_error( "division by zero", line_num, EXPR );
								return_result = INVALID ;
							}	
						}
						break;

					case '%': {	
							if ( first_num != 0 ) {
								result = second_num / first_num;
								return_result = push( result, line_num );
							} else {

								on_error( "modular division by zero", line_num, EXPR );
								return_result = INVALID ;
							}	
						}
						break;

					case 'a' : {
							result = second_num & first_num;
							return_result = push( result, line_num );
						}
						break;

					case 'o' : {
							result = second_num | first_num;
							return_result = push( result, line_num );
						}
						break;	

					case 'x' : {
							result = second_num ^ first_num;
							return_result = push( result, line_num );
						}
						break;


					default: {
							return_result = INVALID;
						}
						break;
				}
			
			} else {
			
				/* if we cant pop an operator, push back
				both of the numbers */

				push( second_num, line_num );
				push( first_num, line_num );
				return_result = INVALID;
			}
		} else {
	
			/* if we cant pop another number, push back the one
			we currently have */

			push( first_num, line_num );
			return_result = INVALID;
		}
	} else {

		/* we cant pop any numbers at all, so something is
		possibly wrong, don't halt the output though leave
		it to the calling function */

		return_result = INVALID;
	}
	print_stack( line_num );
	print_op( line_num );

	if ( diag_state == FULL ) 
		printf( "**calcul ends:**\n\n");

	return return_result;
}

/* minus_sign:	function to convert a minus operator and number to a 
		negative number which is pushed back on the stack */

int minus_sign( int line_num )
{
	extern int diag_state;
	int first_num, return_result=INVALID;
	char operator;

	if ( diag_state == FULL ) 
		printf( "**minus_sign starts:**\n");

	if ( pop_op ( &operator ) == VALID ) {
		if ( operator = '-' ) {
			if ( pop ( &first_num ) == VALID ) {
				first_num = 0 - first_num; 
				push( first_num, line_num );
				return_result = VALID;
			} else {
				on_error( "can't find number for minus operation", line_num, EXPR );
			}
		} else {
			on_error( "minus_sign: is not a minus", line_num, SYSTEM );		
		}
	} else {
		on_error( "minus_sign: no operator available", line_num, SYSTEM );
	}

	if ( diag_state == FULL ) 
		printf( "**minus_sign ends:**\n\n");

	return return_result;

}

/* not_expr:	function to logically NOT an expression works on 
		bytes, words & longs */

int not_expr( int line_num )
{

	extern int diag_state;
	int first_num, return_result = INVALID;
	char operator;

	if ( diag_state == FULL ) 
		printf( "**not_expr starts:**\n");

	if ( pop_op ( &operator ) == VALID ) {
		if ( operator = 'n' ) {
			if ( pop ( &first_num ) == VALID ) {
				if ( first_num <= MAX_ABYTE ){
					printf ( "%d, %d, %d\n", first_num, ~ first_num, 255 & ( ~ first_num ) + 1) ;
					first_num =  ( MAX_ABYTE & ( ~ first_num ) );
				} else {
					first_num = ( MAX_AWORD + 1)  & ( ( ~ first_num ) + 1 );
				}
				push( first_num, line_num );
				return_result = VALID;
			} else {
				on_error( "can't find number for not operation", line_num, EXPR );
			}
		} else {
			on_error( "not_expr: is not a not", line_num, SYSTEM );		
		}
	}

	if ( diag_state == FULL ) 
		printf( "**not_expr ends:**\n\n");

	return return_result;
}



/* brackets:	function to call calul with the brackets option set
		to force calcul to recognise the expression on the
		top of the stack as the result of a parenthisis */

int brackets( int line_num )
{
	extern int diag_state;
	extern int brac_in;

	int return_result;
	char operator;
	
	if ( diag_state == FULL ) 
		printf( "**brackets starts:**\n");

	if ( pop_op ( &operator ) == VALID ) {
		brac_in = IN;
		(void) calcul( line_num );
		print_stack( line_num );
		return_result = VALID;
	} else {
		on_error( "brackets: cant find bracket", line_num, SYSTEM );
		return_result = INVALID;
	}
	if ( diag_state == FULL ) 
		printf( "**brackets ends:**\n\n");

	return return_result;
}
