/* ZUES Assembler source header file -------------------------------*/

/* ######################################### 
   #                                         
   # (C) JPG 1993	yaccin.y                  
   #                                         
   # Version 1.6			     
   #                                         
   # Updated 98/11/19 at 19:27:51                                 
   #                                        
   # ident @(#)yaccin.y	1.6 		     		     
   #                                        
   ######################################### */

/* source starts here			> */

%{
#include "yaccin.h"
%}
%token CEE
%token MOD
%token DIRECTIVE
%token ADDRESS
%token REGISTER
%token IREGISTER
%token INSTRUCTION
%token CUNKNOWN
%token TINSTRUCTION
%token FLAG
%token REGADDRESS
%token ITOKEN
%token COMMA
%token TOKEN
%token NEWLINE
%token CLOSEBR
%token OPENBR
%token PLUS
%token MINUS
%token MULT
%token DIVIDE
%token AND
%token OR
%token NOT
%token XOR
%token HEX
%token HASH
%token BIN
%token OCT
%token STRING
%token CURRENT
%token REGISTERB
%token SREGISTERB
%token SREGISTER
%token OPSQR
%token CLSQR
%token ORG
%token EQU
%token DEFS
%token DEFB
%token DEFM
%token DEFW
%token DEFT
%token END
%token ENT
%start lines
%%

lines 	:
	| NEWLINE { 
			extern int mem_expr; 
			extern int offset;
			extern int not_empty;
			extern int skip_blank;
			extern struct addr_name_list *addr_names;

			if ( ( not_empty == VALID ) || ( skip_blank != VALID ) ) {
				(void) space_gen( linenum );
				(void) print_newline( linenum );
				not_empty = INVALID;
			}
			mem_expr = INVALID;
			linenum++;
			offset = 0;

			addr_names = clear_name_list( addr_names );

			} lines

	| labelit {	
			extern int offset;
			extern int mem_expr; 
			extern struct addr_name_list *addr_names;
 
			(void) print_newline( linenum );
			clear_words( linenum );
			address = address + offset;
			mem_expr = INVALID;

			linenum++;
			offset = 0;
			addr_names = clear_name_list( addr_names );
			} lines

	| declare { 	
			extern int mem_expr; 
			extern int offset;
			extern struct addr_name_list *addr_names;
			int i,temp;

			(void) print_newline( linenum );
			
			clear_words( linenum );
			clear_stacks( &temp );
			mem_expr = INVALID;
			linenum++;
			offset = 0;
			addr_names = clear_name_list( addr_names );
			} lines

	| assem NEWLINE { 
			extern int offset;
			extern int mem_expr; 
			extern struct addr_name_list *addr_names;

			int temp;

			(void) print_newline( linenum );
			clear_words( linenum );
			clear_stacks( &temp );
			address = address + offset;
			mem_expr = INVALID;
			
			linenum++;  
			offset = 0;
			addr_names = clear_name_list( addr_names );
			} lines

	| testset NEWLINE { 
			extern int offset;
			extern int mem_expr; 
			extern struct addr_name_list *addr_names;

			(void) print_newline( linenum );
			clear_words( linenum );
			address = address + offset;
			mem_expr = INVALID;

			linenum++;
			offset = 0;
			addr_names = clear_name_list( addr_names );
			} lines

	| predirec {

			extern int mem_expr; 
			extern int offset;
			extern struct addr_name_list *addr_names;

			(void) print_newline( linenum );
			clear_words( linenum );
			mem_expr = INVALID;
			offset = 0;
			addr_names = clear_name_list( addr_names );
			} lines         

	| skip { 
			extern int mem_expr; 
			extern int offset;
			extern struct addr_name_list *addr_names;

			(void) print_newline( linenum );
			clear_words( linenum );
			mem_expr = INVALID;
			linenum++; 
			offset = 0;
			addr_names = clear_name_list( addr_names );
			} lines         
	;

predirec: HASH expr STRING {
			extern char curr_file[];
			extern int linenum;

			linenum = 0;

			pop_str( curr_file );

			pop( &linenum );	

			linenum--;
		}	

	| HASH expr STRING expr {
			extern char curr_file[];
			extern int linenum;

			int tmp_num;

			pop_str( curr_file );

			pop( &tmp_num );
			pop( &linenum );

			linenum--;

		}	
	;

declare	: o_declare 
	| e_declare NEWLINE
	;

o_declare : ITOKEN o_declare {
				add_label( &last_label, prev_address, VALID, MEM, linenum );
				
			}
			
	| ORG expr NEWLINE {
			extern int assem_state, num_passes;
			extern int linenum, address, prev_address;
			int temp_expr=0,result;

			result=pop(&temp_expr);	
			if ( ( result == INVALID ) && ( assem_state == SECOND_PASS ) ) {
				on_error( "unresolvable expression in origin definition", linenum, FINAL );
			} else if ( ( result == INVALID ) && ( assem_state == FIRST_PASS ) && ( num_passes == 1 ) ) {
				on_error( "unresolved expression in origin definition", linenum, WARN );
			}
			address=temp_expr;
			prev_address=address;
			org_gen( linenum, address );
		}
	| DEFS expr NEWLINE {
			extern int assem_state, num_passes;
			extern int linenum, address, prev_address;
			int temp_expr = 0, result;

			result = pop( &temp_expr );
			if ( ( result == INVALID ) && ( assem_state == SECOND_PASS ) ) {
				on_error( "unresolvable expression in space definition", linenum, FINAL );
			} else if ( ( result == INVALID ) && ( assem_state == FIRST_PASS ) && ( num_passes == 1 ) ) {
				on_error( "unresolved expression in space definition", linenum, WARN );
			}
			org_gen( linenum, address );
			prev_address = address;
			address = address + temp_expr;
		}
	| DEFM strings NEWLINE {
			extern int linenum, offset;
			invert_words( A_STRING, linenum );
			deft_gen( linenum, &offset, address, A_STRING );
			prev_address = address;
			address = address + offset;
		}
	| DEFT strings NEWLINE {
			extern int linenum, offset;
			invert_words( A_TEXT, linenum );
			deft_gen( linenum, &offset, address, A_TEXT );
			prev_address = address;
			address = address + offset;
		}
	| DEFB list NEWLINE {	
			extern int num_in_list, linenum, offset;
			int temp_expr,count=0;
			print_stack( linenum );
			invert_stack( linenum );
			print_stack( linenum );
			defb_gen( linenum, &count, address );
			prev_address = address;
			address = address + num_in_list;
		}
	
				
	| DEFW list NEWLINE {	
			extern int num_in_list, offset;
			int temp_expr;

			offset = 0;
			invert_stack( linenum );
			defw_gen( linenum, &offset, address );
			prev_address = address;
			address = address + ( num_in_list * 2 );
		}
	| ENT NEWLINE {
			(void) space_gen( linenum );
		}
	| END NEWLINE {
			(void) space_gen( linenum );
		}
	;

strings : STRING
	| STRING COMMA strings
	;


list	: expr {
			num_in_list = 1;
		}
	| expr COMMA list {
			num_in_list++;
		}
	;

e_declare : ITOKEN EQU expr { 
			int temp_expr,result;
			result=(pop(&temp_expr));

			(void) space_gen( linenum );
			if ( result != VALID || valid_expr != VALID ){
				add_label( &last_label, temp_expr, INVALID, OTHER, linenum );
			} else {
				add_label( &last_label, temp_expr, VALID, OTHER, linenum );
			}
		}
	;
		

labelit : ITOKEN assem NEWLINE {
			extern int offset;
			extern int address;
			extern int linenum;
			extern char last_label[];

			add_label( &last_label, address, VALID, MEM, linenum );
		}
	| ITOKEN testset NEWLINE {
			extern int offset;
			extern int address;
			extern int linenum;
			extern char last_label[];

			add_label( &last_label, address, VALID, MEM, linenum );
		}
	| ITOKEN NEWLINE {
			extern int offset;
			extern int address;
			extern int linenum;
			extern char last_label[];
			
			(void) space_gen( linenum );
			add_label( &last_label, address, VALID, MEM, linenum );
			offset = 0;
		}
	;

assem	: INSTRUCTION expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
			if ( op_gen( 1, e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
				on_error( "undefined opcode", linenum, SYNTAX );
			}
			
		}
	| INSTRUCTION SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA SREGISTERB {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, r_b_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA REGISTERB {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, rr_, rr_b_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, rr_, rr_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memexpr COMMA REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, E_, rr_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memreg COMMA IREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;
			
			offset = 0;
				if ( op_gen( 3, RR_, i_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION expr COMMA memreg {
			extern int offset;
			extern int address;
			extern int linenum;
			
			offset = 0;
				if ( op_gen( 2, e_, RR_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION expr COMMA REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, e_, rr_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION expr COMMA index {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, e_, i_e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, rr_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION CEE COMMA CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, rr_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION CEE COMMA REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, rr_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, rr_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, rr_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memexpr COMMA SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, E_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memexpr COMMA CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, E_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION expr COMMA SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

	
	
			offset = 0;
				if ( op_gen( 2, e_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
			}
		}
	| INSTRUCTION expr COMMA CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, e_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memreg COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, RR_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memreg COMMA SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;

			offset = 0;
				if ( op_gen( 3, RR_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memreg COMMA CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, RR_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA memexpr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, E_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION CEE COMMA memexpr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, E_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION CEE COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memreg COMMA REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, RR_, rr_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA memreg {
			extern int offset;
			extern int address;
			extern int linenum;
			
			offset = 0;
				if ( op_gen( 3, rr_, RR_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA memexpr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, rr_, E_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, rr_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION index {
			extern int offset;
			extern int address;
			extern int linenum;
			
	
			offset = 0;
	
				if ( op_gen( 2, i_e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
			}
		}

	
	| INSTRUCTION index COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_e_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION index COMMA REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, i_e_, rr_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION index COMMA SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, i_e_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION index COMMA CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, i_e_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA index {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, i_e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION CEE COMMA index {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, i_e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA index {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, rr_, i_e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memexpr COMMA IREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, E_, i_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA REGISTERB {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, r_b_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}

	| INSTRUCTION SREGISTER COMMA CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}

	| INSTRUCTION CEE COMMA SREGISTER {

			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
			
	| INSTRUCTION CEE COMMA REGISTERB {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, r_b_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION REGISTER COMMA IREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, rr_, i_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}


			

			
			
	| INSTRUCTION IREGISTER COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION IREGISTER COMMA memexpr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_, E_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION IREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION IREGISTER COMMA REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, i_, rr_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION IREGISTER COMMA IREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, i_, i_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA memreg {
			extern int offset;
			extern int address;
			extern int linenum;
			
			offset = 0;
				if ( op_gen( 3, r_, RR_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION CEE COMMA memreg {
			extern int offset;
			extern int address;
			extern int linenum;
			
			offset = 0;
				if ( op_gen( 3, r_, RR_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memexpr COMMA IREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, E_, i_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION IREGISTER COMMA memexpr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_, E_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memsreg COMMA SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, R_, r_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION IREGISTER COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION SREGISTER COMMA memsreg {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 3, r_, R_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION memreg {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, RR_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| INSTRUCTION {
			extern int offset;
			extern int address;
			extern int linenum;
			
			offset = 0;
				if ( op_gen( 1, NON, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| AND expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 1, e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| AND SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| AND CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| AND memreg {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, RR_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| AND index {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| OR expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 1, e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| OR SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| OR CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| OR memreg {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, RR_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| OR index {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| XOR expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 1, e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| XOR SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| XOR CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| XOR memreg {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, RR_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| XOR index {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, i_e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	;

testset : TINSTRUCTION FLAG {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, f_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION memind {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, I_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION CEE {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, f_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION FLAG COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, f_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION CEE COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, f_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 1, e_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION memexpr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 1, E_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION memreg {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, RR_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION REGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, rr_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION REGISTER COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, rr_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION SREGISTER {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION SREGISTER COMMA expr {
			extern int offset;
			extern int address;
			extern int linenum;


			

			
			
			offset = 0;
				if ( op_gen( 2, r_, e_, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	| TINSTRUCTION {
			extern int offset;
			extern int address;
			extern int linenum;


			
			
			offset = 0;
				if ( op_gen( 1, NON, NON, NSEQ, NSEQ, &offset, address, linenum ) != VALID ) {
					on_error( "undefined opcode", linenum, SYNTAX );
				}
			
		}
	;

memreg	: OPENBR REGISTER CLOSEBR
	;

memsreg	: OPENBR SREGISTER CLOSEBR
	| OPENBR CEE CLOSEBR
	;

memind	: OPENBR IREGISTER CLOSEBR
	;

memexpr	: OPENBR expr CLOSEBR {
		print_stack( linenum );
	}
	;


index	: OPENBR IREGISTER PLUS expr CLOSEBR {
			char temp_op;

			/* pop the first operator which should be a ) */
			pop_op(&temp_op);

			/* now pop the second which should be a + so calcul isnt confused */
			pop_op(&temp_op);
		}
	;
	

expr	: expr MINUS expr {
			extern int linenum;

			calcul( linenum );
		}
	| expr PLUS expr {
			extern int linenum;

			calcul( linenum );
		}
	| expr MULT expr {
			extern int linenum;

			calcul( linenum );
		}
	| expr MOD expr {
			extern int linenum;

			calcul( linenum );
		}
	| expr DIVIDE expr {
			extern int linenum;

			calcul( linenum );
		}
	| expr XOR expr {
			char temp_str[ MAXLINE ];
	
			pop_text( temp_str );
			calcul( linenum );
			}
	| expr AND expr {
			char temp_str[ MAXLINE ];
	
			pop_text( temp_str );
			calcul( linenum );
			}
	| expr OR expr {
			char temp_str[ MAXLINE ];
	
			pop_text( temp_str );
			calcul( linenum );
			}
	| OPENBR expr CLOSEBR {
			extern int linenum;
			brackets( linenum );
		}
	| MINUS OPENBR expr CLOSEBR {
			extern int linenum;

			minus_sign( linenum );
			brackets( linenum );
		}
	| NOT expr {
			extern int linenum;

			not_expr( linenum );
		}
	| ADDRESS {
			extern int linenum;

		}
	| TOKEN {
			extern int linenum;

		}
	| HEX {
			extern int linenum;

		}
	| BIN {
			extern int linenum;

		}
	| OCT {
			extern int linenum;

		}
	| CURRENT {
			extern int linenum;

		}
	| STRING
	| MINUS ADDRESS {
			extern int linenum;

			minus_sign( linenum );
		}
	;

skip	: error NEWLINE {
			int temp_num;
			yyerrok;
			(void) on_error( "skipping statement..",linenum,SYNTAX);
			clear_stacks( &temp_num );
		}
	
